﻿using System;
using Unit4.CollectionsLib;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class Student
    {
        private string nameStudent;//שם תלמיד
        private string id;//>ת.ז תלמיד
        private List<Subject> listSubject;//רשימת מקצועות
        public Student(string nameStudent, string id)
        {
            this.nameStudent = nameStudent;
            this.id = id;
            this.listSubject = new List<Subject>();
        }
        public string GetNameStudent()
        {
            return this.nameStudent;
        }

        public string GetId()
        {
            return this.id;
        }
        //פעולה מוסיפה מקצוע 
        public void AddSubject(Subject s)
        {
            this.listSubject.Insert(null, s);
        }
        //פעולה המחזירה סה"כ מספר יחידות לימוד
        public int SumPoints()
        {
            int sum = 0;
            Node<Subject> pos = this.listSubject.GetFirst();
            while (pos != null)
            {
                sum = sum + pos.GetInfo().GetPoint();
                pos = pos.GetNext();
            }
            return sum;
        }
        //פעולה מחזירה ממוצע הציונים
        public double GetAverage()
        {
            double sum = 0;
            Node<Subject> pos = this.listSubject.GetFirst();
            while (pos != null)
            {
                if (pos.GetInfo().GetPoint() == 5 && pos.GetInfo().GetNameSubject().Equals("english") || pos.GetInfo().GetNameSubject().Equals("math"))
                    sum = sum + (pos.GetInfo().GetMark() + 25) * pos.GetInfo().GetPoint();
                else if (pos.GetInfo().GetPoint() == 5)
                    sum = sum + (pos.GetInfo().GetMark() + 20) * pos.GetInfo().GetPoint();
                else if (pos.GetInfo().GetPoint() == 4 && pos.GetInfo().GetNameSubject().Equals("english") || pos.GetInfo().GetNameSubject().Equals("math"))
                    sum = sum + (pos.GetInfo().GetMark() + 12.5) * pos.GetInfo().GetPoint();
                else if (pos.GetInfo().GetPoint() == 4)
                    sum = sum + (pos.GetInfo().GetMark() + 10) * pos.GetInfo().GetPoint();
                else sum = sum + (pos.GetInfo().GetMark()) * pos.GetInfo().GetPoint();
                pos = pos.GetNext();
            }
            return (double) sum / SumPoints();
        }
        //פעולה מחזירה אמת אם כל הציונים מעל 55
        public bool IsInncocent()
        {
            Node<Subject> pos = this.listSubject.GetFirst();
            
            while (pos != null)
            {
                if (pos.GetInfo().GetMark() < 55)
                    return false;
                pos = pos.GetNext();
            }
            return true;
        }
        public override string ToString()
        {
            string s = "";
            Node<Subject> pos = this.listSubject.GetFirst();
            while (pos != null)
            {
                s = s + pos.GetInfo() + ",";
                pos = pos.GetNext();
            }
            return s;
        }
        
    }
}